﻿Type=StaticCode
Version=1.70
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Type Filepath(Dir As String, Filename  As String)
	Dim DefaultPort As Int, AllowNonLocalhost As Boolean ,DirNames As List, DirPaths As List , HTTPRequest As List, HTTPValue As List 
	DefaultPort=8080'Can't use 80
	'AllowNonLocalhost is false by default, will only allow 127.0.0.1
	
	dirnames.Initialize 
	dirpaths.Initialize 
End Sub


Sub AddDefaultDirectories
	adddirectory("default", File.DirAssets)
	adddirectory("defaultexternal", File.DirDefaultExternal)
	adddirectory("internal", File.DirInternal)
	adddirectory("internalcache", File.DirInternalCache  )
	adddirectory("root", File.DirRootExternal )
End Sub

Sub AddDirectory(Name As String, Dir As String)As Int 
	Dim index As Int 
	index=FindDirectoryIndex(name)
	If index=-1 Then
		dirnames.Add(name.ToLowerCase)
		dirpaths.Add(dir)
		Return dirnames.Size-1
	Else
		DirPaths.Set(index, Dir)
		Return index
	End If
End Sub
Sub FindDirectoryIndex(Name As String)As Int
	Return DirNames.IndexOf(name.ToLowerCase)
End Sub
Sub FindDirectoryPath(Name As String) As String 
	Dim index As Int 
	index=FindDirectoryIndex(name)
	If index>-1 Then Return dirpaths.Get(index)
End Sub

Sub HandleGetRequest(Buffer() As Byte, AStreams As AsyncStreams)As String 
	Dim msg() As String, temp As Int,temp2 As Int ,tempstr As String, FN As Filepath 
    msg = Regex.Split(CRLF, BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
	HTTPRequest.Initialize
	HTTPValue.Initialize 
	'tempstr.Initialize 
	For temp = 0 To msg.Length -1
		'tempstr.Append(msg(temp))
		If left(msg(temp), 3) = "GET" Then
			msg(temp)=right(msg(temp), msg(temp).Length-4)
			'temp2= msg(temp).LastIndexOf(" ")
			HTTPRequest.Add("get")
			tempstr=getSide(msg(temp), " ", True,False,True)
			HTTPValue.Add(tempstr)
			HTTPRequest.Add("httpversion")
			HTTPValue.Add(getSide(msg(temp), " ", False,False,True))
		Else
			temp2=msg(temp).IndexOf(":")
			If temp2>-1 Then
				HTTPRequest.Add(   left(msg(temp),  temp2).ToLowerCase  )
				HTTPValue.Add(   right(msg(temp), msg(temp).Length- temp2-1) )
			End If
		End If
	Next
	fn=MapDirectory(tempstr)
	
	SendText(AStreams,GenerateHTTPResponse(Fn))
	
	Return tempstr 
End Sub
Sub GetHTTPRequestValue(Request As String)As String
	Dim temp As Int 
	temp = HTTPRequest.IndexOf(request.ToLowerCase)
	If temp>-1 Then Return HTTPValue.Get(temp)
End Sub

Sub GenerateHTTPResponse(FN As Filepath)As String 
	'HTTP/1.1 200 OK
	'Content-Type: text/xml; charset=utf-8
	'Content-Length: length
		Dim tempstr As String 
	If File.Exists(fn.Dir, fn.Filename) Then
		tempstr= File.GetText(fn.Dir,fn.Filename)
		Return "HTTP/1.1 200 OK" & CRLF & "Content-Type: text/html; charset=utf-8" & CRLF & "Content-Length: " & tempstr.Length & CRLF & CRLF & tempstr
	Else
		Return "HTTP/1.1 404 NOT FOUND"
	End If
End Sub


Sub SendText(AStreams As AsyncStreams, Text As String)
	Dim buffer() As Byte
	If AStreams.IsInitialized Then
    	buffer = Text.GetBytes("UTF8")
    	AStreams.Write(buffer)
	End If
End Sub

Sub MapDirectory(Dir As String) As Filepath
	Dim Filename As Filepath, temp As Int
	filename.Initialize 
	Filename.Filename=getside(dir, "/", False,False,False)
	Filename.Dir=getside(dir, "/", True, False,False)
	If Filename.Dir.Length=0 Then 
		Filename.Dir = FindDirectoryPath("default")
	Else
		temp=FindDirectoryIndex(filename.Dir)
		If temp>-1 Then
			Filename.Dir = dirpaths.Get(temp)
		Else
			Filename.Dir = FindDirectoryPath("default")
		End If
	End If
	If Filename.Filename.Contains("/") Then
		Filename.Dir = File.Combine(Filename.Dir, getside(Filename.Filename, "/",  True,False,True) )
		Filename.Filename=getside(Filename.Filename, "/",  False,False,True)
	End If
	Return filename
End Sub











Sub getSide(Text As String, Delimeter As String, LeftSide As Boolean,DoRightSide As Boolean , Last As Boolean  ) As String 
	Dim temp As Int
	If text.Contains(delimeter) Then
		If Last Then
			temp=text.LastIndexOf(Delimeter)
		Else
			temp=text.IndexOf(Delimeter)
		End If
		If leftside Then
			Return left(text,temp)
		Else
			Return right(text, text.Length-temp-1)
		End If
	Else
		If leftside OR DoRightSide Then Return text
	End If
End Sub
Sub Left(Text As String, Length As Long)As String 
	If length>text.Length Then length=text.Length 
	Return text.SubString2(0, length)
End Sub
Sub Right(Text As String, Length As Long) As String
	If length>text.Length Then length=text.Length 
	Return text.SubString(text.Length-length)
End Sub
Sub Mid(Text As String, Start As Int, Length As Int) As String 
	If Length>0 AND start>-1 AND start< text.Length Then Return text.SubString2(start,start+length)
End Sub